#include "bullet.h"
#include "player.h"

GLfloat bullet::maxspeed = 0.5;

// constructor.  gets reference to player passed so the bullet's initial
// position can be set to the player's (along with angle and some other stuff
bullet::bullet(void *e)
{
	alive = true;
	enemy *temp;
	temp = (enemy*)e;

	position[x] = temp->pos[x]; position[y] = temp->pos[y]; position[z] = temp->pos[z];

	angle = temp->fire_angle;
	
	// nice red laser bullet
	dif[0] = 1.0; dif[1] = 0.0; dif[2] = 0.0;

	// no speed in z direction, but x and y are calculated based on the inherited
	// angle from player object.  converted to radians for ease of use
	speed[x] = maxspeed * sin((-angle / 180.0) * 3.1415926);
	speed[y] = maxspeed * cos((-angle / 180.0) * 3.1415926);
	speed[z] = 0;
}

void bullet::draw()
{
	glPushMatrix();
		glMateriali(GL_FRONT, GL_SHININESS, 96);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, dif);
		// translate to player position
		glTranslatef(position[x], position[y], position[z]);
		glPushMatrix();
			// then rotate to appropriate angle
			glRotatef(angle, 0.0, 0.0, 1.0);
			glutSolidCylinder(0.5, 0.05, 16, 16);
		glPopMatrix();
	glPopMatrix();
}