#include "player.h"
#include "bullet.h"

GLfloat player::angle_speed = 4.0;

// constructor calls parent class to default to <0, 0, 0>
player::player() : enemy(0.0, 0.0, 0.0)
{
	alive = true;
	fire_angle = 0.0;

	maxspeed[x] = 1.0;
	maxspeed[y] = 0.0;
	maxspeed[z] = 0.0;


	// like enemy, specify diffuse and specular for player parts
	bottom_dif[x] = 0.0; bottom_dif[y] = 0.0; bottom_dif[z] = 0.0;
	bottom_spc[x] = 0.1; bottom_spc[y] = 0.1; bottom_spc[z] = 0.1;

	top_dif[x] = 1.0; top_dif[y] = 1.0; top_dif[z] = 1.0;
	top_spc[x] = 0.75; top_spc[y] = 0.75; top_spc[z] = 0.75;
}

void player::draw()
{
	glPushMatrix();
		glTranslatef(pos[x], pos[y], pos[z]);
		
		// draw square base
		glPushMatrix();
			glMateriali(GL_FRONT, GL_SHININESS, 0);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, bottom_dif);
			glMaterialfv(GL_FRONT, GL_SPECULAR, bottom_spc);
			glScalef(1.0, 0.5, 1.0);
			glutSolidCube(1.0);
		glPopMatrix();

		// draw top of dome
		glPushMatrix();
			glMateriali(GL_FRONT, GL_SHININESS, 96);
			glTranslatef(0.0, 0.25, 0.0);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, top_dif);
			glMaterialfv(GL_FRONT, GL_SPECULAR, top_spc);
			glScalef(1.0, 0.75, 1.0);
			glutSolidSphere(0.25, 16, 16);
		glPopMatrix();

		// draw firing rod
		glPushMatrix();
			glMateriali(GL_FRONT, GL_SHININESS, 96);
			glRotatef(fire_angle, 0.0, 0.0, 1.0);
			glTranslatef(0.0, 0.5, 0.0);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, top_dif);
			glMaterialfv(GL_FRONT, GL_SPECULAR, top_spc);
			glutSolidCylinder(0.5, 0.05, 16, 16);
		glPopMatrix();
	glPopMatrix();
}

void player::fire()
{
	deleteBullet();									// only allows 1 bullet at a time
	bullet *b = new bullet((void*)this);			// creates new bullet and sets the
	mybullet = b;									// player's void pointer to it
}