#include <iostream>
#include <glut.h>
#include <cmath>
#include <3DGraphics.h>
#include <cstdlib>

using namespace std;

#pragma comment(lib, "3DGraphics.lib")


const GLint sizeV = 4;
const GLint sizeF = 2;
GLfloat texCoords[sizeV][2] = {{0.0, 0.0}, {1.0, 0.0}, {1.0, 1.0}, {0.0, 1.0}};
GLfloat vertices[sizeV][3] = {{-3.5, 2.2, 0.5}, {3.5, 2.2, 0.5}, {3.5, -2.2, 0.5}, {-3.5, -2.2, 0.5}};
short face_indicies[sizeF][9] = {{2, 1, 0, 0, 0, 0, 1, 2, 3}, {3, 2, 0, 0, 0, 0, 0, 1, 3}};
GLfloat normals[sizeF][3] = {{0.0, 0.0, 0.0}, {0.0, 0.0, 0.0}};

GLfloat dsl = 0.1;

const GLint nTextures = 1;
unsigned int textureNames[1];
char *fileName[1] = {"scale.bmp"};

void drawObject()
{
	glPushMatrix();
		Draw3DTextureObject(face_indicies, normals, vertices, texCoords, sizeF, textureNames[0]);
	glPopMatrix();
}
void display()
{
	glClearColor(0.0, 0.0, 0.0, 0.0); // RGBA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// camera by default looks in the -z direction
	glPushMatrix(); // put current matrix into stack
		glTranslatef(0.0, 0.0, -6.0); // x, y, z. moves object 30 units back
		glRotatef(angleViewX, 1.0, 0.0, 0.0);
		glRotatef(angleViewY, 0.0, 0.0, 1.0); 
		drawObject();
	glPopMatrix(); // restore stack;
	glutSwapBuffers(); // GL uses two buffers to reduce flickering
	glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y)
{
	if (key == 27) exit(0);
	if (key == 'n' || key == 'N')
	{
		if (vertices[0][0] < -3.5 || vertices[0][0] > -2.0) dsl *= -1.0;
		for (int i = 0; i < sizeV; i++)
		{
			for (int j = 0; j < 2; j++)
			{
				if (vertices[i][j] < 0) vertices[i][j] += dsl;
				else if (vertices[i][j] > 0) vertices[i][j] -= dsl;
			}
		}
	}
	glutPostRedisplay();
	
}

int main(int args, char **argsv)
{
	glutInit(&args, argsv);
	init(); // from wani's lib
	initTexture(textureNames, fileName, nTextures);
	glutDisplayFunc(display); // calls display function from above
	glutKeyboardFunc(keyboard);
	glutMainLoop();
}




